
#include "CACHE.hpp"

#ifndef _H_CS_TRIPLET
#define _H_CS_TRIPLET

template< typename T >
class CS_Triplet {

   protected:

	unsigned long int row;
	unsigned long int column;

   public:
	
	const unsigned long int i() {
		CACHE::getInstance()->access( &row, sizeof( unsigned long int ) );
		return row;
	}

	const unsigned long int j() {
		CACHE::getInstance()->access( &column, sizeof( unsigned long int ) );
		return column;
	}

	T value;

	T& getValue() {
		CACHE::getInstance()->access( &value, sizeof( T ) );
		return value;
	}

	CS_Triplet( unsigned long int i, unsigned long int j, T val ): row( i ), column( j ), value( val ) {}
	CS_Triplet(): row( 0 ), column( 0 ), value( 0 ) {}

};

#endif

