
#ifndef _H_CS_STATUS
#define _H_CS_STATUS

/** Class (struct) to simplify keeping cache statistics. */
class STATUS {
   public:
	/** Number of times cpu-to-cache latency occured. */
	unsigned long int _lc;

	/** How much units of cpu-to-cache bandwith was needed. */
	unsigned long int _bc;

	/** Number of times cache-to-main memory latency occured. */
	unsigned long int _lm;

	/** How much units of cache-to-main memory bandwith was needed. */
	unsigned long int _bm;

	/** How many cache misses occured. */
	unsigned long int _misses;

	/** How many initial cache misses occurred. 
	 *  Initial cache misses correspond to data items brought into
	 *  cache for the first time.
	 */
	unsigned long int _initialMisses;

	/** How many cache hits occured. */
	unsigned long int _hits;

	/** @return The number of total misses, that is,
	 *          the sum of the initial and non-initial misses.
	 */
	unsigned long int totalMisses() const { return ( _misses + _initialMisses ); }
};

#endif
